//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3D173C8B0390.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3D173C8B0390.cm

//## begin module%3D173C8B0390.cp preserve=no
//## end module%3D173C8B0390.cp

//## Module: Minuit%3D173C8B0390; Package body
//## Subsystem: XSFit::FitMethod::Minuit%3D173C150170
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSFit/FitMethod/Minuit/Minuit.cxx

//## begin module%3D173C8B0390.additionalIncludes preserve=no
//## end module%3D173C8B0390.additionalIncludes

//## begin module%3D173C8B0390.includes preserve=yes
//## end module%3D173C8B0390.includes

// Minuit
#include <XSFit/FitMethod/Minuit/Minuit.h>
//## begin module%3D173C8B0390.declarations preserve=no
//## end module%3D173C8B0390.declarations

//## begin module%3D173C8B0390.additionalDeclarations preserve=yes
#include <Minuit/MinuitCtoF.h>
#include <XSFit/Fit/StatMethod.h>
#include <XSFit/Fit/Fit.h>
#include <XSUtil/Utils/XSutility.h>
#include <XSstreams.h>
#include <typeinfo>
#include <cstring>

extern "C"
{
   void svdcmp_(double* a, int& m, int& n, int& mp, int& np, double* w,
                double* v, double* rv1);  

}
//## end module%3D173C8B0390.additionalDeclarations


// Class Minuit 

//## begin Minuit::logicUnit%473A0C6D017F.attr preserve=no  private: static int {U} 0
int Minuit::s_logicUnit = 0;
//## end Minuit::logicUnit%473A0C6D017F.attr

//## begin Minuit::objCount%473A0CA50180.attr preserve=no  private: static int {U} 0
int Minuit::s_objCount = 0;
//## end Minuit::objCount%473A0CA50180.attr

Minuit::Minuit(const Minuit &right)
  //## begin Minuit::Minuit%3D1738660026_copy.hasinit preserve=yes
  : FitMethod(right)
  //## end Minuit::Minuit%3D1738660026_copy.hasinit
  //## begin Minuit::Minuit%3D1738660026_copy.initialization preserve=yes
  //## end Minuit::Minuit%3D1738660026_copy.initialization
{
  //## begin Minuit::Minuit%3D1738660026_copy.body preserve=yes
  if (s_logicUnit == 0)
  {
     // This is the first time copy ctor is called, which means
     // it is the first time a user has attempted to set a
     // Minuit fit method.  Open Minuit log file here, and don't 
     // close it until program exits.
     s_logicUnit = 15;
     mnfopn_(s_logicUnit);
  }
  const int five(5), seven(7);
  mninit_(five,s_logicUnit,seven);
  mncler_();
  
  ++s_objCount;
  //## end Minuit::Minuit%3D1738660026_copy.body
}

Minuit::Minuit (const string& initString)
  //## begin Minuit::Minuit%3D173A0F027C.hasinit preserve=yes
        : FitMethod(initString)
  //## end Minuit::Minuit%3D173A0F027C.hasinit
  //## begin Minuit::Minuit%3D173A0F027C.initialization preserve=yes
  //## end Minuit::Minuit%3D173A0F027C.initialization
{
  //## begin Minuit::Minuit%3D173A0F027C.body preserve=yes
  firstDerivativeRequired(true);
  secondDerivativeRequired(false);
  ++s_objCount;
  //## end Minuit::Minuit%3D173A0F027C.body
}


Minuit::~Minuit()
{
  //## begin Minuit::~Minuit%3D1738660026_dest.body preserve=yes
  --s_objCount;
  if (s_objCount == 0)
  {
     if (s_logicUnit)
     {
        mnfcls_(s_logicUnit);
        s_logicUnit = 0;
     }
  }
  else if (s_logicUnit)
  {
     int ierr=0;
     mnflsh_(s_logicUnit, ierr);
     if (ierr)
        tcerr << "***Warning: Minuit output log file has reached its size limit.\n"
              << "            Part of the file may be overwritten." << std::endl;   
  }
     
  //## end Minuit::~Minuit%3D1738660026_dest.body
}



//## Other Operations (implementation)
void Minuit::doPerform (Fit* fit)
{
  //## begin Minuit::doPerform%3D1739A001A2.body preserve=yes
  // Driver program for Minuit.  The C++ version of minfit.f.
  
  int ierr=0, ivar, narg;
  Real val, err, bn1, bn2, arglst[2]={0.,0.};
  char errCommand[]="SET ERRORDEF";
  char setgrad[]="SET GRADIENT";
  char hesse[]="HESSE";
  
  StatMethod* stat = fit->statMethod();
   
  std::map<int,ModParam*>::const_iterator vp = fit->variableParameters().begin();
  std::map<int,ModParam*>::const_iterator vpEnd   = fit->variableParameters().end();
  //Name array must be large enough to handle the 'undefined' string that Minuit
  //could conceivably place in it.
  char name[10];
  strcpy(name,"param");
  
  mncler_();
  ivar = 1;
  while (vp != vpEnd)
  {
     ModParam& current = *(vp->second);
     val = current.value('a');
     err = current.value('d');
     bn1 = bn2 = 0.;
     MNPARM(ivar, name, val, err, bn1, bn2, ierr);
     ++ivar;
     ++vp;
  } 
     
  arglst[0] = 1;
  narg=1;
  MNEXCM(C_FUNCTION(MNCALCSTAT, mncalcstat), setgrad, arglst, narg, ierr, 0); 
  
  arglst[0] = Fit::deltaStat();
  narg = 1;
  MNEXCM(C_FUNCTION(MNCALCSTAT, mncalcstat), errCommand, arglst, narg, ierr, 0);     
  
  string commandStr(selectedSubMethod());
  if (commandStr == "monte")
     commandStr = "seek";
  char* minuitCmd = new char[commandStr.length()+1];
  strcpy(minuitCmd, commandStr.c_str());
  narg = (commandStr == string("improve")) ? 1 : 2;
  arglst[0] = numberOfTrials();
  // migrad's stopping criterion is .001*<deltaCrit>*UP where
  // UP is deltaStat.
  arglst[1] = deltaCrit();
  MNEXCM(C_FUNCTION(MNCALCSTAT, mncalcstat), minuitCmd, arglst, narg, ierr, 0); 
  delete [] minuitCmd;
  
  narg = 1;
  arglst[0] = numberOfTrials();
  MNEXCM(C_FUNCTION(MNCALCSTAT, mncalcstat), hesse, arglst, narg, ierr, 0);
  
  vp = fit->variableParameters().begin();
  ivar = 1;
  while (vp != vpEnd)
  {
   // No check for frozen is performed - all in the variableParameters array
   // should be unfrozen.     
     ModParam& current = *(vp->second);
     MNPOUT(ivar, name, val, err, bn1, bn2, ierr); 
     current.setValue(val, 'a');    
     current.setValue(err, 's');
     Real eplus, eminus, eparab, globcc;
     mnerrs_(ivar, eplus, eminus, eparab, globcc);
     current.setValue(eparab, 'r');
     current.setValue(globcc, 'g');
     ++ivar;
     ++vp;
  }
  stat->perform(fit);
  
  if (!fit->errorCalc())
  {
     int nPar = fit->variableParameters().size();
     XSutility::auto_array_ptr<double> pCovar(new double[nPar*nPar]);
     double* covar = pCovar.get();
     mnemat_(covar, nPar);
     RealArray& coVariance = covariance();
     coVariance.resize(nPar*nPar);
     // Fortran/C ordering difference shouldn't matter for
     // covar since it's symmetric, but still reversing i and j
     // to be consistent.
     for (int i=0; i<nPar; ++i)
     {
        for (int j=0; j<nPar; ++j)
        {
          coVariance[i*nPar + j] = covar[j*nPar + i];
        }
     }
     XSutility::auto_array_ptr<double> pVmat(new double[nPar*nPar]);
     XSutility::auto_array_ptr<double> pRv1(new double[nPar]);
     XSutility::auto_array_ptr<double> pEvalue(new double[nPar]);
     double* evalue = pEvalue.get();
     double* vmat = pVmat.get();
     double* rv1 = pRv1.get();
     // Note: this call will change covar.
     svdcmp_(covar, nPar, nPar, nPar, nPar, evalue, vmat, rv1);
     fit->fitMethod()->setEvalue(RealArray(evalue, nPar));
     RealArray& eVector = evector();
     eVector.resize(nPar*nPar);
     // Account for Fortran vs. C difference in matrix ordering
     for (int i=0; i<nPar; ++i)
     {
        for (int j=0; j<nPar; ++j)
        {
           eVector[i*nPar + j] = vmat[j*nPar + i];
        }
     }
  }
  
  ierr=0;
  mnflsh_(s_logicUnit, ierr);
  if (ierr)
     tcerr << "***Warning: Minuit output log file has reached its size limit.\n"
           << "            Part of the file may be overwritten." << std::endl;   
  //## end Minuit::doPerform%3D1739A001A2.body
}

void Minuit::copy (const FitMethod& right)
{
  //## begin Minuit::copy%3D173A360266.body preserve=yes
  if ( typeid(*this) != typeid(right) ) 
          throw RedAlert("*** Programmer Error: copying to wrong type ***");  
  Minuit that(static_cast<const Minuit&>(right));
  swap(that);   
  //## end Minuit::copy%3D173A360266.body
}

void Minuit::swap (FitMethod& right)
{
  //## begin Minuit::swap%3D173A7403CA.body preserve=yes
  FitMethod::swap(right);
//  Minuit&  that = static_cast<Minuit&>(right);
  //## end Minuit::swap%3D173A7403CA.body
}

Minuit* Minuit::clone () const
{
  //## begin Minuit::clone%3D173E0B016D.body preserve=yes
  //## end Minuit::clone%3D173E0B016D.body

  return new Minuit(*this);
}

bool Minuit::getErrors (Fit* fit, const string& modelName, const IntegerArray& paramNums)
{
  //## begin Minuit::getErrors%3D48052402F3.body preserve=yes
  int ierr=0;
  char errCommand[]="SET ERRORDEF";
  Real errArg[1];
  errArg[0] = Fit::deltaStat();
  int nErrArg=1;
  MNEXCM(C_FUNCTION(MNCALCSTAT, mncalcstat), errCommand, errArg, nErrArg, ierr, 0);     

    
  char command[]="MINOS";
  int narg=0, ivar=1;
    
  narg = paramNums.size() + 1;
  RealArray tmp(.0, narg-1);
  XSutility::auto_array_ptr<Real> pArglst(new Real[narg]); 
  Real* arglst = pArglst.get();
  arglst[0] = numberOfTrials();
  for (int i=1; i<narg; i++)
  {
     std::map<int,ModParam*>::const_iterator vp 
     		= fit->variableParameters().find(paramNums[i-1]);
     std::map<int,ModParam*>::difference_type dist=0;
#ifndef STD_COUNT_DEFECT
     dist = distance(fit->variableParameters().begin(),vp);
#else
     distance(fit->variableParameters().begin(),vp, dist);
#endif     
     ivar = 1 + static_cast<int>(dist);
     arglst[i] = ivar;
     ModParam& current = *(vp->second);
     tmp[i-1] = current.value('v');
  }
  
  MNEXCM(C_FUNCTION(MNCALCSTAT, mncalcstat), command, arglst, narg, ierr, 0);
  
  for (int i=0; i<narg-1; i++)
  {
     Real eplus, eminus, eparab, globcc;
     // No checking performed here to see if parameter with key =
     // paramNums[i] exists in map.  This should already have been
     // accomplished by the checking performed in the Fit::getErrors
     // wrapper.
     std::map<int,ModParam*>::const_iterator vp 
     		= fit->variableParameters().find(paramNums[i]);
     std::map<int,ModParam*>::difference_type dist=0;
#ifndef STD_COUNT_DEFECT
     dist = distance(fit->variableParameters().begin(),vp);
#else
     distance(fit->variableParameters().begin(),vp, dist);
#endif     
     ivar = 1 + static_cast<int>(dist);
     ModParam& current = *(vp->second);
     mnerrs_(ivar, eplus, eminus, eparab, globcc);

     current.setValue(tmp[i]+eplus, 'p');
     current.setValue(tmp[i]+eminus, 'm');
     current.setValue(tmp[i], 'v');
     reportMinos(current);
  }
  
  return true;
  //## end Minuit::getErrors%3D48052402F3.body
}

string Minuit::settingString () const
{
  //## begin Minuit::settingString%3F3CE5F400B8.body preserve=yes
  return string();
  //## end Minuit::settingString%3F3CE5F400B8.body
}

string Minuit::fullName () const
{
  //## begin Minuit::fullName%3FCE0D150263.body preserve=yes
  return string("Minuit ") + selectedSubMethod();
  //## end Minuit::fullName%3FCE0D150263.body
}

void Minuit::reportMinos (const ModParam& param) const
{
  //## begin Minuit::reportMinos%41A392490194.body preserve=yes
  using namespace std;
  
  ios_base::fmtflags saveFlags(tcout.flags());
  tcout.precision(6);
  tcout << setw(6) << param.index() << setw(13) << param.value('m') 
        << setw(13) << param.value('p') << "   (" << param.value('m') -
        param.value('v') << "," << param.value('p') - param.value('v')
        << ")" << endl;
  tcout.flags(saveFlags);
  //## end Minuit::reportMinos%41A392490194.body
}

void Minuit::improve (Fit* fit)
{
  //## begin Minuit::improve%467A97770190.body preserve=yes
   const string saveSubMethod(selectedSubMethod());
   selectedSubMethod("improve");
   try
   {
      doPerform(fit);
   }
   catch (...)
   {
      selectedSubMethod(saveSubMethod);
      // Seems unlikely anthing should throw in doPerform, but
      // if it does we'll conservatively assume fit is no longer 
      // in a valid state.
      fit->isStillValid(false);
      throw;
   }
   selectedSubMethod(saveSubMethod);
  //## end Minuit::improve%467A97770190.body
}

// Additional Declarations
  //## begin Minuit%3D1738660026.declarations preserve=yes
  //## end Minuit%3D1738660026.declarations

//## begin module%3D173C8B0390.epilog preserve=yes
//## end module%3D173C8B0390.epilog
